# Baremetal Introspection API

## The Baremetal Introspection Proxy

The baremetal introspection high-level interface is available through the `baremetal_introspection` member of a `Connection` object. The `baremetal_introspection` member will only be added if the service is detected.

### Introspection Process Operations

class openstack.baremetal_introspection.v1._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  introspections(**query)

    Retrieve a generator of introspection records.

    Parameters:

      query (dict) –

      Optional query parameters to be sent to restrict the records to be returned. Available parameters include:

      - `fields`: A list containing one or more fields to be returned in the response. This may lead to some performance gain because other fields of the resource are not refreshed.

      - `limit`: Requests at most the specified number of items be returned from the query.

      - `marker`: Specifies the ID of the last-seen introspection. Use the `limit` parameter to make an initial limited request and use the ID of the last-seen introspection from the response as the `marker` value in a subsequent limited request.

      - `sort_dir`: Sorts the response by the requested sort direction. A valid value is `asc` (ascending) or `desc` (descending). Default is `asc`. You can specify multiple pairs of sort key and sort direction query parameters. If you omit the sort direction in a pair, the API uses the natural sorting direction of the server attribute that is provided as the `sort_key`.

      - `sort_key`: Sorts the response by the this attribute value. Default is `id`. You can specify multiple pairs of sort key and sort direction query parameters. If you omit the sort direction in a pair, the API uses the natural sorting direction of the server attribute that is provided as the `sort_key`.

    Returns:

      A generator of `Introspection` objects

  start_introspection(node, manage_boot=None)

    Create a new introspection from attributes.

    Parameters:

      - node – The value can be either the name or ID of a node or a `Node` instance.

      - manage_boot (bool) – Whether to manage boot parameters for the node. Defaults to the server default (which is True).

    Returns:

      `Introspection` instance.

  get_introspection(introspection)

    Get a specific introspection.

    Parameters:

      introspection – The value can be the name or ID of an introspection (matching bare metal node name or ID) or an `Introspection` instance.

    Returns:

      `Introspection` instance.

    Raises:

      `NotFoundException` when no introspection matching the name or ID could be found.

  get_introspection_data(introspection, processed=True)

    Get introspection data.

    Parameters:

      - introspection – The value can be the name or ID of an introspection (matching bare metal node name or ID) or an `Introspection` instance.

      - processed – Whether to fetch the final processed data (the default) or the raw unprocessed data as received from the ramdisk.

    Returns:

      introspection data from the most recent successful run.

    Return type:

      dict

  abort_introspection(introspection, ignore_missing=True)

    Abort an introspection.

    Note that the introspection is not aborted immediately, you may use wait_for_introspection with ignore_error=True.

    Parameters:

      - introspection – The value can be the name or ID of an introspection (matching bare metal node name or ID) or an `Introspection` instance.

      - ignore_missing (bool) – When set to `False`, an exception `NotFoundException` will be raised when the introspection could not be found. When set to `True`, no exception will be raised when attempting to abort a non-existent introspection.

    Returns:

      nothing

  wait_for_introspection(introspection, timeout=None, ignore_error=False)

    Wait for the introspection to finish.

    Parameters:

      - introspection – The value can be the name or ID of an introspection (matching bare metal node name or ID) or an `Introspection` instance.

      - timeout – How much (in seconds) to wait for the introspection. The value of `None` (the default) means no client-side timeout.

      - ignore_error – If `True`, this call will raise an exception if the introspection reaches the `error` state. Otherwise the error state is considered successful and the call returns.

    Returns:

      `Introspection` instance.

    Raises:

      `ResourceFailure` if introspection fails and `ignore_error` is `False`.

    Raises:

      `ResourceTimeout` on timeout.

this page last updated: 2026-01-16 23:06:19

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.